<manifest version="4.0" type="device" target-level="4">
    <hal format="hidl">
        <name>android.hardware.audio</name>
        <transport>hwbinder</transport>
        <fqname>@7.0::IDevicesFactory/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.audio.effect</name>
        <transport>hwbinder</transport>
        <fqname>@7.0::IEffectsFactory/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.biometrics.fingerprint</name>
        <transport>hwbinder</transport>
        <fqname>@2.1::IBiometricsFingerprint/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.bluetooth</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IBluetoothHci/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.bluetooth.audio</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::IBluetoothAudioProvidersFactory/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.camera.provider</name>
        <transport>hwbinder</transport>
        <fqname>@2.5::ICameraProvider/external/0</fqname>
        <fqname>@2.5::ICameraProvider/legacy/0</fqname>
        <fqname>@2.5::ICameraProvider/virtual/0</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.configstore</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::ISurfaceFlingerConfigs/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.drm</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::ICryptoFactory/cdrm</fqname>
        <fqname>@1.2::IDrmFactory/cdrm</fqname>
        <fqname>@1.4::ICryptoFactory/clearkey</fqname>
        <fqname>@1.4::ICryptoFactory/widevine</fqname>
        <fqname>@1.4::IDrmFactory/clearkey</fqname>
        <fqname>@1.4::IDrmFactory/widevine</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.gatekeeper</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IGatekeeper/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.gnss</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IGnss/default</fqname>
        <fqname>@2.0::IGnss/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.graphics.allocator</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::IAllocator/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.graphics.composer</name>
        <transport>hwbinder</transport>
        <fqname>@2.4::IComposer/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.graphics.mapper</name>
        <transport arch="32+64">passthrough</transport>
        <fqname>@2.1::IMapper/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.ir</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IConsumerIr/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.keymaster</name>
        <transport>hwbinder</transport>
        <fqname>@3.0::IKeymasterDevice/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.light</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::ILight/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.media.omx</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IOmx/default</fqname>
        <fqname>@1.0::IOmxStore/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.memtrack</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IMemtrack/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.nfc</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::INfc/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.power</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IPower/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.radio</name>
        <transport>hwbinder</transport>
        <fqname>@1.6::IRadio/slot1</fqname>
        <fqname>@1.6::IRadio/slot2</fqname>
        <fqname>@1.6::IRadio/slot3</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.radio.config</name>
        <transport>hwbinder</transport>
        <fqname>@1.3::IRadioConfig/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.renderscript</name>
        <transport arch="32+64">passthrough</transport>
        <fqname>@1.0::IDevice/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.secure_element</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::ISecureElement/SIM1</fqname>
        <fqname>@1.0::ISecureElement/eSE2</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.sensors</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::ISensors/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.soundtrigger</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::ISoundTriggerHw/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.thermal</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IThermal/default</fqname>
        <fqname>@2.0::IThermal/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.weaver</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IWeaver/huaweiweaver</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.wifi</name>
        <transport>hwbinder</transport>
        <fqname>@1.5::IWifi/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.activity_recognition</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IActivityRecognition/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.ai</name>
        <transport>hwbinder</transport>
        <fqname>@1.3::IAiEngineService/hiaiserver</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.ai</name>
        <transport>hwbinder</transport>
        <fqname>@2.1::IAIService_hidl/hiaiserver_v2</fqname>
        <fqname>@2.1::IModelManagerService_hidl/hiaiserver_modelmanager</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.ai.dedicatedmm</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IDedicatedMM/hiaiserver_dedicatedmm</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.ai.hidlrequest</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHidlRequest/ai_fmk_hidl_service</fqname>
        <fqname>@1.0::IHidlRequest/aiengine_server</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.ai.om</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IOmHidlBridge/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.ai.security</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IAISecurityRecipient/hiaiserver_security_recipient</fqname>
        <fqname>@1.0::IAISecurityService/hiaiserver_security</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.ai.stats</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IAiStatsService/aiserver_record_stats</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.aonn</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::IAiIgsService/aiserver_igs</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.audioremote</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IAudioRemoteConnect/default</fqname>
        <fqname>@1.1::IAudioRemoteConnect/virtualmodem</fqname>
        <fqname>@1.2::IAudioRemoteConnect/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.biometrics.fingerprint</name>
        <transport>hwbinder</transport>
        <fqname>@2.2::IExtBiometricsFingerprint/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.biometrics.hwfacerecognize</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::IBiometricsFaceRecognize/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.biometrics.hwsecurefacerecognize</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::ISecureBiometricsFaceRecognize/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.biometrics.hwvoiceid</name>
        <transport>hwbinder</transport>
        <fqname>@2.1::IBiometricsVoiceId/hwvoiceid</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.bluetooth</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHwBluetoothHciExt/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.camera.camResource</name>
        <transport>hwbinder</transport>
        <fqname>@1.6::IHwCameraResourceService/huawei.cameraresource.service</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.camera.cfgsvr</name>
        <transport>hwbinder</transport>
        <fqname>@1.4::IHwCamCfgSvr/huawei.camera.cfgsvr</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.camera.factory</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::ICameraFactory/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.camera.imageEnhance</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::IIVEDeferProcSvr/default</fqname>
        <fqname>@1.2::IIVEIPS/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.camera.vircamera</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IVirCameraChannel/virtualcamera.register</fqname>
        <fqname>@1.0::IVirCameraChannel/virtualcamera.streamchange</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.ctxhub_ble</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IBleInterface/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.dolby.dms</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IDms/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.dubai</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IDubaiManager/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.eid</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IEid/eid</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.fm</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IFmControl/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.fusd</name>
        <transport>hwbinder</transport>
        <fqname>@1.10::IFusdLbs/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.gnss</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::IHWGnss/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.graphics.hwcinterface</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::IHwcInterface/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.graphics.mediacomm</name>
        <transport>hwbinder</transport>
        <fqname>@2.2::IMediaComm/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hinetmanager</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHinetmanagerDevice/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hisiradio</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::IHisiRadio/slot1</fqname>
        <fqname>@1.2::IHisiRadio/slot2</fqname>
        <fqname>@1.2::IHisiRadio/slot3</fqname>
        <fqname>@1.3::IHisiRadio/slot1</fqname>
        <fqname>@1.3::IHisiRadio/slot2</fqname>
        <fqname>@1.3::IHisiRadio/slot3</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hivrar</name>
        <transport>hwbinder</transport>
        <fqname>@2.3::IHiVRAR/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hmiservice</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::IHmiService/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.huawei_security_vnode</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHwSecurityVNode/HwInSExtNode</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.huaweiantitheft</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHuaweiAntiTheft/huaweiantitheft</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.huaweisigntool</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::ISignTool/huaweisigntool</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwairsensing</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IAirSensing/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwairsensing.provider</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IAirSensingProvider/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwdisplay</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IDisplay/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwdisplay.displayengine</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::IDisplayEngineWrapper/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwfactoryinterface</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IHwFactoryInterface/hwfactoryinterface_hal</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwfs</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHwfs/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwhiview</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IHwHiviewInterface/hwhiview_hal</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwsched</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::ISched/hwsched</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwstp</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::IHwStp/hwstp</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwupdate</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHwUpdate/hwupdate_hal</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hyperhold</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IPersistingData/hyperhold_hal</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.iawareperf</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IUniPerf/uniperf</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.iawareperfpolicy</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IPerfPolicy/perfpolicy</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.iked</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IIkedDevice/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.irsl</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IIrselflearning/irselflearning</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.jpegdec</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IJpegDecode/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.kds</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IKds/kds</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.libteec</name>
        <transport>hwbinder</transport>
        <fqname>@3.0::ILibteecGlobal/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.light</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::ILight/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.modemchr</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IModemchrDevice/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.modemlogcat</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IModemlogcat/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.modempatch</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHwmodempatch/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.motion</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IMotion/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.nfc</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHWNfc/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.nxpnfc</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::INxpNfc/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.perfgenius</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::IPerfGenius/perfgenius</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.power</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHWPower/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.radio</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::IRadio/slot1</fqname>
        <fqname>@2.0::IRadio/slot2</fqname>
        <fqname>@2.0::IRadio/slot3</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.radio.chr</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IRadioChr/slot1</fqname>
        <fqname>@1.0::IRadioChr/slot2</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.radio.deprecated</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IOemHook/slot1</fqname>
        <fqname>@1.0::IOemHook/slot2</fqname>
        <fqname>@1.0::IOemHook/slot3</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.radio.distributed</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IDistributed/slot1</fqname>
        <fqname>@1.0::IDistributed/slot2</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.radio.dvmodem</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IDVModemHook/slot1</fqname>
        <fqname>@1.0::IDVModemHook/slot2</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.radio.ims</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::IRadioIms/rildi</fqname>
        <fqname>@2.0::IRadioIms/rildi2</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.radio.sateradio</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::ISateradio/slot1</fqname>
        <fqname>@1.0::ISateradio/slot2</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.sensors</name>
        <transport>hwbinder</transport>
        <fqname>@1.3::ISensors/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.sle</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::ISleHci/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.smc</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::ISmc/default</fqname>
        <fqname>@1.0::ISmcCallback/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.tp</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::ITouchscreen/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.vpeer.p2ptransport</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IP2pTransport/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.vpeer.vpeerfusion</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IVpeerFusion/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.weaver</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IWeaver/huaweiweaver</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.wifi</name>
        <transport>hwbinder</transport>
        <fqname>@1.3::IHwWifiExt/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.wifi.stereo</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IStereo/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.wifi.supplicant</name>
        <transport>hwbinder</transport>
        <fqname>@4.0::ISupplicant/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.wifi.waudio</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IWaudio/default</fqname>
    </hal>
</manifest>
